#!/bin/bash

# Get the directory of the script
SCRIPT_DIR=$(dirname "$(realpath "$0")")

# Change to the script's directory
cd "$SCRIPT_DIR"

# Check if svunit submodule exists
if [ ! -f "../svunit/Setup.bsh" ]; then
    # If the file does not exist, run git submodule update
    echo "SVUnit Setup.bsh does not exist. Updating submodules..."
    ( cd ../../ && git submodule update --init --recursive )
fi
# Source the Setup.bsh script from the ../svunit/ directory
cd ../svunit/ && source Setup.bsh

# Change to the script's directory
cd "$SCRIPT_DIR"

# To run all unit test templates within a given parent directory
# runSVUnit -s questa -o tmp_svunit -r "-suppress 12003,8386" -r "-voptargs=+acc" -r "-sv_seed random" "$@"

# To run specific unit test template within a given parent directory
runSVUnit -s questa -o tmp_svunit -r "-suppress 12003,8386" -r "-voptargs=+acc" -r "-sv_seed random" -t modul_studenta_unit_test.sv -r "-do ../modul_studenta_unit_test.do" -d SIMULATION=1 "$@"

# Example of run in GUI
# ./run_svunit.sh -r -gui

# Example of run and define set
# ./run_svunit.sh -d MY_DEFINE=1